<?xml version="1.0" encoding="UTF-8"?>
<!-- 
/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL                                       
 * All rights reserved.                                                    
 * Please look at license.txt in info directory for more license detail.   
 **************************************************************************/
JSR-170
xsl used to execute xpath queries to Doc View 

 @author <a href="mailto:alex.kravchuk@gmail.com">Alexander Kravchuk</a>
 @version $Id: doc-view-xpath.xsl 1210 2005-05-08 16:42:22Z kravchuk $
 
-->
<!--substitute @namespaces@ with namespaces declarations -->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" @namespaces@ >

	<xsl:output method="xml" encoding="UTF-8" standalone="yes" omit-xml-declaration="no" indent="no" cdata-section-elements="property"/>

	<xsl:template match="/">
		<xsl:element name="xml">
			<xsl:apply-templates/>
		</xsl:element>
	</xsl:template>
	

<!-- xpath query substite @xpath@ in  <xsl:variable name="res" select="@xpath@"  -->
	<xsl:template match="jcr:root" >
			<xsl:variable name="res" select="@xpath@"/>
			<xsl:for-each select="$res">
				<xsl:apply-templates select="." mode="system" />
			</xsl:for-each>
	</xsl:template>

	<xsl:template match="node()" mode="system">
		<xsl:element name="node">
			<xsl:attribute name="nodePath">
				<xsl:call-template name="get-abs-path"/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>

	<xsl:template match="@*" mode="system">
		<xsl:apply-templates select="parent::*" mode="system"/>
	</xsl:template>
	
	
	<!--	set node index (node-name[indx]) if node have preceding same name sibling -->
	<xsl:template name="node-index">
			<xsl:variable name="node-name" select="name()"/>			
			<xsl:variable name="preceding-same-name-sibling" select="count(preceding-sibling::*[name()=$node-name])"/>
			<xsl:if test="$preceding-same-name-sibling > 0">
				<xsl:text>[</xsl:text>
				<xsl:value-of select="$preceding-same-name-sibling+1"/>	
				<xsl:text>]</xsl:text>			
			</xsl:if>	
	</xsl:template>
	

	
	<!-- format absolute jcr path to current node 	-->
	<xsl:template name="get-abs-path">
		<xsl:text>/</xsl:text>
		<xsl:call-template name="parent-node-iterator"/>
		<xsl:if test="name() != 'jcr:root' ">
			<xsl:value-of select="name()"/>
			<xsl:call-template name="node-index"/>		
		</xsl:if>
	</xsl:template>
	
	<!-- auxiliary template for  "get-abs-path", iterate all nodes, except current and root -->
	<xsl:template name="parent-node-iterator">
		<xsl:for-each select="parent::*[name() != 'jcr:root' ]">
			<xsl:call-template name="parent-node-iterator"/>
			<xsl:value-of select="name()"/>
			<xsl:call-template name="node-index"/>			
			<xsl:text>/</xsl:text>
		</xsl:for-each>
	</xsl:template>
	
	<!-- override default template-->
	<xsl:template match="text() | @*"/>
</xsl:stylesheet>
