<?xml version="1.0" encoding="UTF-8"?>
<!-- 
/***************************************************************************
 * Copyright 2001-2005 The eXo Platform SARL                                       
 * All rights reserved.                                                    
 * Please look at license.txt in info directory for more license detail.   
 **************************************************************************/
JSR-170
xsl used to execute xpath queries to System View 

 @author <a href="mailto:alex.kravchuk@gmail.com">Alexander Kravchuk</a>
 @version $Id: system-view-xpath.xsl 1181 2005-04-29 09:13:43Z kravchuk $
 
-->
<xsl:stylesheet version="2.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:sv="http://www.jcp.org/jcr/sv/1.0" exclude-result-prefixes="sv">
	<xsl:output method="xml" encoding="UTF-8" standalone="yes" omit-xml-declaration="no" indent="no" cdata-section-elements="property"/>
	<!-- xpath query substite @xpath@ in  <xsl:variable name="res" select="@xpath@"  -->
	<xsl:template match="/">
		<xsl:element name="xml">
			<xsl:variable name="res" select="@xpath@ "/>
			<xsl:for-each select="$res">
				<xsl:apply-templates select="."/>
			</xsl:for-each>
		</xsl:element>
	</xsl:template>
	

	<xsl:template match="sv:node">
		<xsl:element name="node">
			<xsl:attribute name="nodePath">
				<xsl:call-template name="get-abs-path"/>
			</xsl:attribute>
		</xsl:element>
	</xsl:template>

	<xsl:template match="sv:property">
		<xsl:element name="property">
			<xsl:attribute name="nodePath">
				<xsl:for-each select="parent::sv:node"><xsl:call-template name="get-abs-path"/></xsl:for-each>
			</xsl:attribute>
			<xsl:attribute name="name"><xsl:value-of select="@sv:name"/></xsl:attribute>
			<xsl:attribute name="type"><xsl:value-of select="@sv:type"/></xsl:attribute>

			<!-- WARNING: only  first property's value extracted, 
			      because of javax.jcr.Query  -->
			<xsl:apply-templates select="sv:value[1]" mode="prop_value"/>
		</xsl:element>
	</xsl:template>
	
	<xsl:template match="sv:value" mode="prop_value">
		<xsl:value-of select="."/>
	</xsl:template>
	
	
	<!-- format absolute jcr path to current node 	-->
	<xsl:template name="get-abs-path">
		<xsl:text>/</xsl:text>
		<xsl:call-template name="parent-node-iterator"/>
		<xsl:if test="@sv:name != 'jcr:root' ">
			<xsl:value-of select="@sv:name"/>
		</xsl:if>
	</xsl:template>
	
	<!-- auxiliary template for  "get-abs-path", iterate all nodes, except current and root -->
	<xsl:template name="parent-node-iterator">
		<xsl:for-each select="parent::*[@sv:name != 'jcr:root' ]">
			<xsl:call-template name="parent-node-iterator"/>
			<xsl:value-of select="@sv:name"/>
			<xsl:text>/</xsl:text>
		</xsl:for-each>
	</xsl:template>
	
	<!-- override default template-->
	<xsl:template match="text() | @*"/>
</xsl:stylesheet>
